#!/usr/bin/python3
# -*- coding: utf-8 -*-
import os
import requests
import requests.utils
import pickle
import random
import string
from fake_useragent import UserAgent
from sys import argv,exc_info
from hashlib import md5
import re
import random

ERROR   = 110
SUCCESS = 101
CORRUPT = 102
MUMBLE  = 103
DOWN    = 104

DEBUG = True
PORT = "8000"
ua = UserAgent()

textmassiv = {'Знакомство с OpenGL':'В мире существует огромное количество приложений на OpenGL, и, кажется, Apple c этим не вполне согласна. Начиная с iOS 12 и MacOS Mojave, OpenGL переведен в статус устаревшего. Мы интегрировали Apple Metal в MAPS.ME и готовы поделиться своим опытом и результатами. Расскажем, как рефакторили наш графический движок, с какими трудностями пришлось столкнуться и, самое главное, сколько у нас теперь FPS.Всех, кто заинтересовался или раздумывает над добавлением поддержки Apple Metal в графический движок, приглашаем под кат.','SQL инъекции':'SQL инъекция — это один из самых доступных способов взлома сайта. Суть таких инъекций – внедрение в данные (передаваемые через GET, POST запросы или значения Cookie) произвольного SQL кода. Если сайт уязвим и выполняет такие инъекции, то по сути есть возможность творить с БД (чаще всего это MySQL) что угодно.','Django':'Django (/ˈdʒæŋɡoʊ/ джанго) — бесплатный и свободный фреймворк для веб-приложений, написанный на Python. Фреймворк — это набор компонентов, которые помогают разрабатывать веб-сайты быстро и просто.Каждый раз при разработке веб-сайтов требуются похожие компоненты: способ аутентифицировать пользователей (вход, выход, регистрация), панель управления сайтом, формы, инструменты для загрузки файлов и т. д.','Шаблоны Django':'Будучи веб фреймверком, Django позволяет динамически генерировать HTML. Самый распространенный подход - использование шаблонов. Шаблоны содержат статический HTML и динамические данные, рендеринг которых описан специальным синтаксисом. Пример использования шаблонов для создания HTML шаблонов можно найти в учебнике ','СуперИван':'Студент третьего курса ОмГТУ радиотехнического факультета специальности «Комплексная защита информационных систем» Иван Таг вошел в число призеров Летней школы CTF в Дубне.Летняя школа CTF проходит в подмосковном городе Дубна уже на протяжении пяти лет. Мероприятие собирает большое число студентов и школьников, интересующихся информационной безопасностью. В этом году в мероприятии участвовало более 80 студентов из 23 российских городов.Кроме того, каждый год Летнюю школу посещают легенды мира информационной безопасности. В этом году в числе экспертов были Михаил Якобсен (Transdata AS, Норвегия), Сергей Голованов (ведущий эксперт Лаборатории Касперского), и другие.Омич Иван Таг вошел в тройку лучших по итогам рейтинговой системы. В октябре он будет участвовать в Школе по кибербезопасности в Сколково.','The Outer Worlds':'Редактор Kotaku Джейсон Шрайер пообщался с Майки Даулингом, директором по коммуникациям студии Obsidian. Он рассказал журналисту, что грядущая игра The Outer Worlds разрабатывается с конца 2016 года.Игру издаст Private Division, принадлежащая Take-Two Interactive. Дочерняя компания специализируется на AA-проектах со средним бюджетом. Шрайер отметил, что по масштабам The Outer Worlds не сможет конкурировать с крупнобюджетными тайтлами вроде Fallout New Vegas или третьего «Ведьмака»','Итоги выставки «ИгроМир 2018»':'В этом году «ИгроМир 2018» и Comic Con Russia посетило более 170 тысяч посетителей за четыре дня работы. Более 200 компаний представили главные новинки игрового мира и поп-культуры на более чем 210 стендах и торговых местах. Экспозиция заняла четыре зала первого павильона «Крокус Экспо» общей площадью 26.500 кв.м. В бизнес-дне выставок (4 октября) приняло участие 25 000 человек, а все дни работы «ИгроМира 2018» и Comic Con Russia мероприятия освещали более 2000 представителей медиа.','Территория Интерактивных Развлечений':'«ИгроМир» - это первая в России полномасштабная выставка для всех любителей интерактивных развлечений: компьютерных игр, игр для консолей, мобильных телефонов и других платформ. Это увлекательная экскурсия по виртуальным мирам и реальным эмоциям, возможность раньше других оценить игровые новинки и своими глазами увидеть тех, кто их делает.','Компания Ubisoft объявляет об участии в выставке ИгроМир 2018':'Компания Ubisoft объявляет об участии в выставке ИгроМир 2018 с 4 по 7 октября и делится первыми подробностями об активностях на мероприятии. Главным событием станет уникальная возможность сыграть в Tom Clancy’s The Division 2 и «Assassin’s Creed Одиссея» на стенде компании (G3, Зал №3)*. Первые посетители соответствующих демо-зон получат памятные подарки.','Собственные шаблонные теги и фильтры':'Django содержит большое количество встроенных тегов и фильтров. Тем не менее, вам может понадобиться добавить собственный функционал к шаблонам. Вы можете сделать это добавив собственную библиотеку тегов и фильтров используя Python, затем добавить ее в шаблон с помощью тега {% load %}','Как вычислить уязвимость, позволяющую внедрять SQL инъекции?':'Довольно легко. Например, есть тестовый сайт test.ru. На сайте выводится список новостей, с возможностью детального просомтра. Адрес страницы с детальным описанием новости выглядит так: test.ru/?detail=1. Т.е через GET запрос переменная detail передаёт значение 1 (которое является идентификатором записи в табице новостей).Изменяем GET запрос на ?detail=1". Далее пробуем передавать эти запросы серверу, т.е заходим  на test.ru/?detail=1".Если при заходе на данные страницы появляется ошибка, значит сайт уязвим на SQL инъекции.','«Бука» разыграет сотни призов и представит свои проекты на «ИгроМире»!':'Основная часть стенда будет посвящена одному из самых ожидаемых шутеров следующего года — «Метро: Исход». Гости «ИгроМира» смогут первыми пройти один из красивейших уровней игры на мощных консолях Xbox One X и новейших игровых компьютерах Hyper PC, оснащенных передовыми видеокартами NVIDIA GeForce RTX 2080 Ti с поддержкой технологии NVIDIA RTX. ','ЦСКА разгромил "Реал" в матче Лиги чемпионов':'Встреча группа G, прошедшая в среду в Мадриде, завершилась со счетом 3:0 в пользу ЦСКА.Голы в составе армейцев забили Федор Чалов (37-я минута), Георгий Щенников (43) и Арнор Сигурдссон (73).Домашнее поражение стало самым крупным в истории для мадридского "Реала" в еврокубках.','В следующем году в Омске появится электробус':'Директор департамента транспорта Александр Вялков рассказал NGS55.RU, что планирует привезти в Омск электробусы — пока дело ограничится лишь одной машиной. В феврале следующего года опытный образец получим, — коротко прокомментировал глава дептранса.','Не щадя ягодиц: в Омске прошёл чемпионат по тверку':'В баре SVOИ в ночь с субботы на воскресенье прошёл первый открытый чемпионат по тверку. Главным призом были 10 000 рублей. За них решили сразиться пять девушек: Елена Карапетян, Дарья Сидельникова, Танзиля Бахтиярова (тёзка известной омской телеведущей), Полина Соколова и Валерия Старикова. Все девчонки — омички, они занимаются разными направлениями танцев. Елена и Дарья сами преподают различные направления в одной из омских танцевальных школ.','Кибербезопасник -соревнования “Capture The Flag”':'Завтра на базе Московского кадетского музыкального корпуса ГБОУ ШКОЛА 1770 по адресу Москва, Коломенская набережная, 20 состоится Хакатон под названием "Кибербезопасник", где в течение 4 часов начинающие борцы с киберугрозами и представители информационной безопасности будут решать различные задания. Главной особенностью является факт наличия у участников нулевого или начального уровня профильной подготовки.','II Кубок CTF России - как это было':'II Кубок CTF России 30 ноября - 1 декабря состоялся II Кубок CTF России в инновационном центре "Сколково".', 'II Кубок CTF России уже завтра!':'II Кубок CTF России Завтра, 30 ноября, стартует долгожданное CTF-событие нашей страны, один из крупнейших турниров страны в области информационной безопасности, а именно II Кубок CTF России. Эти соревнования позволят победителям различных региональных и столичных CTF-соревнований побороться за звание самой эффективной команды страны.','Skolkovo Cyberday 2018 — новые возможности обеспечения безопасности':'Skolkovo Cyberday 2018 30 ноября - 1 ноября на международной конференции Skolkovo Cyberday 2018, которая состоится в Инновационном центре «Сколково», ведущие эксперты расскажут о новых методах и инструментах обеспечения кибербезопасности. В рамках мероприятия также пройдут мастер-классы и питч-сессия стартапов.','В «Сколково» стартует международный конкурс Skolkovo Cybersecurity Challenge':'Skolkovo Cyberday 2018 1 декабря 2018 года начнется прием заявок на участие в ежегодном конкурсе инновационных проектов в сфере кибербезопасности в рамках конференции Skolkovo Cyberday 2018. Конкурс Skolkovo Cybersecurity Challenge посвящен поиску лучших инновационных решений в области защиты бизнеса и частных лиц от киберугроз.','II Кубок CTF России':'II Кубок CTF России 30 ноября - 1 декабря пройдет один из крупнейших турниров страны в области информационной безопасности II Кубок CTF России. Этот проект позволит лучшим региональным командам студентов, школьников, учащихся ссузов, а также разработчикам CTF-турниров побороться за звание чемпиона страны.','ITSEC + ALL-OVER-IP 2018':'Введите описание изображения 21-23 ноября в Москве в КВЦ «Сокольники» прошла XV международная выставка ITSEC – Информационная безопасность России /InfoSecurity Russia 2018, а вместе с ней XI международный форум All-over-IP 2018.','Skolkovo Cyberday 2018':'Skolkovo Cyberday 2018 30 ноября – 1 декабря в Инновационном центре «Сколково» состоится международная конференция Skolkovo Cyberday 2018. Ежегодное мероприятие посвящено актуальным вопросам развития технологий в области кибербезопасности. Организаторами конференции выступают Кластер информационных технологий Фонда «Сколково» и Межрегиональная общественная организации «Ассоциация руководителей служб информационной безопасности» (МРОО «АРСИБ»)','II Кубок CTF России — встречаем команду SITIS':'SITIS До начала II Кубка CTF России остается все меньше времени, а значит пришло время приоткрыть некоторые тайны, и рассказать, кто будет принимать участие в соревнованиях и бороться за титул самой эффективной команды страны!','GoCTF-2018':'GoCTF 2018 17-18 ноября 2018 года в ГБПОУ КСТ в УК №5 «Ярославский» состоялся финал Конкурса профессионального мастерства «Открытые соревнования по информационной безопасности среди команд обучающихся профессиональных образовательных организаций GoCTF-2018».','MIEM CTF 2018':'MIEM CTF 2018 В субботу, 17 ноября состоялся финал соревнований MIEM CTF 2018. Само мероприятие проводилось на базе МИЭМ НИУ ВШЭ. В соревнованиях приняло участие 28 команд из различных вузов страны.','Skolkovo Cyberday 2018':'Skolkovo Cyberday 2018 30 ноября – 1 декабря в Инновационном центре «Сколково» состоится международная конференция Skolkovo Cyberday 2018. Ежегодное мероприятие посвящено актуальным вопросам развития технологий в области кибербезопасности. Организаторами конференции выступают Кластер информационных технологий Фонда «Сколково» и Межрегиональная общественная организации «Ассоциация руководителей служб информационной безопасности» (МРОО «АРСИБ»)','РеверсБум':'РеверсБум «РеверсБум» — многие слышали об этой игре, но не все знают, в чем ее идея. Чтобы внести ясность наша сотрудница Софья Стаценко пообщалась с Максимом Баклановским, одним из разработчиков «РеверсБум».','Олимпиада Университета Иннополиса по информационной безопасности':'Открытая Олимпиада 9 декабря стартует первый этап Открытой Олимпиады Университета Иннополиса для школьников по информационной безопасности. В Олимпиаде могут принять участие учащиеся 9-11 классов общеобразовательных учреждений России и зарубежья. Регистрация открыта до 3 декабря!','GoCTF-2018':'GoCTF-2018 17-18 ноября 2018 года в Колледже современных технологий (г. Москва) состоится основной этап Конкурса профессионального мастерства «Открытые соревнования по информационной безопасности среди обучающихся профессиональных образовательных организаций GoCTF -2018».','M*CTF 2018!':'MCTF-2018 10-11 ноября, на прошедших выходных состоялся финал соревнований MCTF-2018. В финальном этапе участвовало 10 команд различных московских вузов, само же мероприятие состоялось в Конгресс-центре МТУСИ.','Открываем набор волонтёров на II Кубок CTF России!':'II Кубок СTF России 30 ноября - 1 декабря на базе Инновационного Центра «Сколково» пройдут Всероссийские соревнования в области информационной безопасности — II Кубок CTF России. Участниками станут студенческие и школьные команды, а также команды колледжей, которые заняли первые места на региональных соревнованиях формата CTF. Кроме того, на площадке будет возможность посетить конференции Skolkovo Cyberday 2018 и БИТ.','Skolkovo Cyberday 2018':'Skolkovo Cyberday 2018 30 ноября – 1 декабря в Инновационном центре «Сколково» состоится международная конференция Skolkovo Cyberday 2018. Ежегодное мероприятие посвящено актуальным вопросам развития технологий в области кибербезопасности. Организаторами конференции выступают Кластер информационных технологий Фонда «Сколково» и Межрегиональная общественная организации «Ассоциация руководителей служб информационной безопасности» (МРОО «АРСИБ»)','II Кубок CTF России — рассказываем об этапе task-based':'II Кубок CTF России Начало II Кубка CTF России продолжает приближаться, поэтому сегодня мы продолжим раскрывать тайны организаторов и рассказывать инсайдерскую информацию о том, кто же создает задания для предстоящих соревнований!','InnoCTF 2018':'InnoCTF 2018 3 ноября состоялся отборочный онлайн-тур на очередные межвузовские соревнования по информационной безопасности InnoCTF 2018, которые пройдут в самом молодом городе страны — Иннополисе.','M*CTF 2018!':'MCTF-2018 10-11 ноября в Москве, в Конгресс-центре МТУСИ, пройдет финал соревнований MCTF-2018. В финале могут принять участие только команды московских вузов.','II Кубок CTF России: встречаем нового члена жюри — заслуженного системного инженера Cisco Михаила Кадера':'Михаил Кадер Начало II Кубка CTF России все ближе, а значит, сегодня мы вновь расскажем немного эксклюзивной информации о том, кто же возьмет на себя роль жюри в финальных CTF-соревнованиях 2018 года!','КиберЗарница 2018':'КиберЗарница 2018 Сегодня, 3 ноября 2018 года для кадетов Москвы впервые прошла военно-патриотическая игра «КиберЗарница». Участие в ней приняли 5 образовательных учреждений.','КиберЗарница':'КиберЗарница Завтра, 3 ноября 2018 года, для кадетов Москвы впервые пройдет военно-патриотическая игра «КиберЗарница». http://киберзарница.рф','II Кубок CTF России — рассказываем об этапе attack-defense':'II Кубок CTF России Начало II Кубка CTF России продолжает приближаться, поэтому сегодня мы продолжим раскрывать тайны организаторов и рассказывать инсайдерскую информацию о том, кто же создает задания для предстоящих соревнований!','GoCTF-2018':'GoCTF-2018 27-28 октября прошел отборочный этап GoCTF-2018. По итогам которого в финал вышли 29 команд различных российских колледжей. Финал пройдет на базе Колледжа современных технологий (г. Москва) уже 17-18 ноября 2018 года.','II Кубок CTF России — встречаем команду null.dat':'II Кубок CTF России До начала II Кубка CTF России остается все меньше времени, а значит пришло время приоткрыть некоторые тайны, и рассказать, кто будет принимать участие в соревнованиях и бороться за титул самой эффективной команды страны!','OldSchoolCTF-2018':'OldSchoolCTF-2018 4 ноября состоится долгожданное CTF-событие города Хабаровска, а именно OldSchoolCTF-2018! Сегодня же стартовала онлайн-регистрация на отборочный тур соревнований.','II Кубок CTF России: встречаем члена жюри — известного программиста Дмитрия Склярова':'Дмитрий Скляров Начало II Кубка CTF России продолжает приближаться, поэтому сегодня мы продолжим раскрывать тайны организаторов и рассказывать инсайдерскую информацию о том, кто же возьмет на себя роль жюри в финальных CTF-соревнованиях 2018 года!','CrimeaCTF 2018':'CrimeaCTF 2018 25 октября в Симферополе на базе физико-технического института КФУ состоялись студенческие межвузовские соревнования в области информационной безопасности CrimeaCTF 2018. Вчера, 26 октября там же прошли соревнования школьников и средних технических заведений.','InnoCTF 2018':'InnoCTF 2018 В городе Иннополисе стартовала регистрация на отборочный тур на очередные межвузовские соревнования по информационной безопасности InnoCTF 2018.','SibirCTF-2018':'SibirCTF-2018 С 19 по 21 октября в городе Томске состоится Молодежный форум «Information Security of the Internet and Business – ISIB’18», в рамках которого состоялись соревнования SibirCTF-2018.','GoCTF-2018':'GoCTF-2018 17-18 ноября 2018 года в Колледже современных технологий (г. Москва) состоится основной этап Конкурса профессионального мастерства «Открытые соревнования по информационной безопасности среди обучающихся профессиональных образовательных организаций GoCTF -2018».','II Кубок CTF России — встречаем команду DirtyBytes':'DirtyBytes До начала II Кубка CTF России остается все меньше времени, а значит пришло время приоткрыть некоторые тайны, и рассказать, кто будет принимать участие в соревнованиях и бороться за титул самой эффективной команды страны!','Завершился отборочный этап M*CTF 2018!':'M*CTF 2018 22 октября завершился отборочный этап MCTF 2018, по итогу которого в финал соревнований вышли 10 команд различных московских вузов. Всего на соревнования было зарегистрировано 82 команды, из них 53 — из вузов.','II Кубок CTF России: встречаем члена жюри — ведущего специалиста по конкурентной разведке Андрея Масаловича':'Андрей Масалович Начало II Кубка CTF России все ближе, а значит, сегодня мы вновь расскажем немного эксклюзивной информации о том, кто же возьмет на себя роль жюри в финальных CTF-соревнованиях 2018 года!','II Кубок CTF России: встречаем члена жюри — ведущего аналитика Group-IB Павла Супрунюка':'Павел Супрунюк До начала II Кубка CTF России остается все меньше времени, а значит пришло время приоткрыть некоторые тайны, и рассказать, кто будет судить и радовать своим присутствием участников соревнований в этом году!','Skolkovo Cyberday 2018':'Skolkovo Cyberday 2018 30 ноября – 1 декабря в Инновационном центре «Сколково» состоится международная конференция Skolkovo Cyberday 2018. Ежегодное мероприятие посвящено актуальным вопросам развития технологий в области кибербезопасности. Организаторами конференции выступают Кластер информационных технологий Фонда «Сколково» и Межрегиональная общественная организации «Ассоциация руководителей служб информационной безопасности» (МРОО «АРСИБ»)','Online-соревнования «OATCTF-2018»':'OATCTF-2018 В воскресенье, 14 октября 2018 года, состоялись мини-киберучения среди команд студентов учебных заведений Омска и соседних регионов в формате межвузовского online-соревнования в области информационной безопасности (attack/defense) «OATCTF-2018».','Участвуй в виртуальном чемпионате «Изучи интернет - управляй им»':'Стартовала регистрация на VII Всероссийский онлайн-чемпионат для школьников «Изучи интернет – управляй им». Регистрация открыта до 5 ноября 2018 года. К участию в Чемпионате приглашаются дети и подростки до 18 лет, которые могут выступить как в индивидуальном зачете, так и объединившись в команды.','DagCTF-2018':'28-30 сентября 2018 г. в ГАОУ ВО «Дагестанский государственный университет народного хозяйства» прошли IV-е студенческие межвузовские соревнования в области информационной безопасности «DagCTF-2018» среди участников образовательных организаций высшего образования по международным правилам «Capture the flag». Всего приняло участие 7 команд.','В Red Dead Online включили «донат» — теперь слитки можно покупать за деньги':'Rockstar Games опубликовала на своём сайте свежий отчёт о ходе тестирования Red Dead Online. Авторы рассказали о последних событиях в жизни сетевого вестерна.Прежде всего, для RDO вышел апдейт 1.05. Ничего сверхъестественного в патч не входит — он повышает стабильность игры, улучшает сохранение данных и устраняет «эксплойты».В качестве благодарности за участие в «бете» Rockstar подарит игрокам 15 золотых слитков. Чтобы получить награду, нужно зайти в Online до 20 декабря. Бонус будет зачислен на ваш аккаунт не позже 24 декабря.','В 2019 году магазин Discord откроется для всех разработчиков. Сервис будет забирать лишь 10 % выручки':'Пока публика спорила, сможет ли цифровой магазин Epic Games потягаться со Steam, к вечеринке присоединилась Discord. Создатели одноимённого мессенджера объявили, что в 2019 году игры на их торговой площадке смогут продавать все разработчики, а доля сервиса от выручки составит всего 10 %.','В Magic: The Gathering Arena появился русский перевод':'Коллекционная карточная игра — явно не из тех жанров, где можно обойтись без русскоязычного перевода. Теперь цифровая Magic: The Gathering Arena готова принять тех, кто, как говорится, учил в школе немецкий, — в игру ввели русскую локализацию.','Epic Games заставила датамайнера закрыть сайт, посвящённый утечкам из Fortnite [обновлено]':'Обновлено 14 декабря в 22:25 по московскому времени. Epic Games дала комментарий GamesIndustry.biz. По словам представителя компании, закрытие сайта не связано непосредственно с датамайнингом и утечками. Дело в том, что ресурс рекламировал инструменты для модификации игры, использование которых нарушает условия обслуживания.','Дорогое издание Anthem получило собственный трейлер':'На YouTube-канале IGN появился свежий трейлер боевика Anthem. На первый взгляд может показаться, что видео посвящено вымышленной организации Легион Рассвета, но на самом деле это в первую очередь реклама издания, названного в честь ордена.','В Британии появился первый в мире профсоюз работников игровой индустрии':'После скандала вокруг Rockstar Games, когда выяснилось, что многие сотрудники компании страдают от переработок, или кранчей, представители игровой индустрии вновь заговорили о создании профсоюзов. Сегодня стало известно, что объединение девелоперов станет частью Независимого союза работников Великобритании.','Для Dishonored 2 и Death of the Outsider выпустили немножко бесплатного контента':'Даже в одиночных играх Bethesda начинает поощрять геймеров, которые привязываются к площадке Bethesda.net. В октябре пользователям сервиса вручили хардкорный режим «Акуму» в The Evil Within 2, а теперь россыпь бонусов появилась в Dishonored 2 и Dishonored: Death of the Outsider.','Сервер для Minecraft превратится в отдельную игру при поддержке авторов League of Legends':'В Minecraft существует сервер Hypixel, который привлёк свыше 14 миллионов игроков и даже попал в Книгу рекордов Гиннесса как самый популярный независимый сервер в видеоиграх. В итоге создатели Hypixel основали Hypixel Studios и теперь готовят своего «убийцу Minecraft» — Hytale.','Не ждите от The Outer Worlds масштабов Fallout: New Vegas':'Самые смекалистые могли сразу догадаться, что The Outer Worlds от Obsidian не станет действительно большой игрой, сравнимой с Fallout: New Vegas. Kotaku эти догадки подтверждает: скорее всего, грядущее приключение окажется относительно компактным.','Создатели «Итана Картера» начинают делиться подробностями о шутере Witchfire':'The Astronauts — польская компания, где трудятся некоторые разработчики Painkiller и Bulletstorm. В 2014 году студия выпустила «симулятор ходьбы» The Vanishing of Ethan Carter, который завоевал множество наград, а в декабре 2017-го анонсировала шутер Witchfire… и скрылась с радаров на целый год.','PlanetSide Arena — мультиплеерный шутер с «Королевской битвой» на 500 человек':'Daybreak Game Company (создательница H1Z1 и Everquest) анонсировала PlanetSide Arena — новую игру в серии мультиплеерных шутеров PlanetSide. Она следует модным веяниям индустрии, но не станет зацикливаться на «Королевской битве» и предложит в том числе другие развлечения.','DayZ дожила до релиза. Вы можете попробовать её бесплатно':'Итак, 13 декабря завершилась целая эпоха — эпоха, когда DayZ обитала в раннем доступе и грустно смотрела, как спадает пик популярности «выживачей». Разработчики сдержали слово и выпустили версию 1.0 до конца 2018-го.','Blizzard сокращает поддержку Heroes of the Storm и отменяет киберспортивную часть':'Считается, что Heroes of the Storm — одна из самых неудачных игр современной Blizzard. «Моба» не завоевала такой же популярности, как другие проекты компании, и теперь это наконец аукнулось: Blizzard заявила, что сокращает поддержку игры.','Героиня NieR: Automata появится в SoulCalibur VI уже через несколько дней':'В конце октября Bandai Namco анонсировала кроссовер между SoulCalibur VI и NieR: Automata — в файтинг заглянет протагонистка NieR 2B. Сегодня компания объявила, когда именно станет доступен новый боец.','В честь старта зимней распродажи в GOG.com раздают ремастер Full Throttle':'Сезон праздничной халявы продолжает цифровой магазин GOG.com — на площадке стартовала зимняя распродажа. Владельцы сервиса постарались угодить и тем, кто готов заплатить совсем немного, и тем, кто вовсе не хочет расставаться с кровно заработанными.','«Метро: Исход» выйдет раньше, чем вы думали':'Deep Silver и 4A Games спешат поделиться приятной новостью — релиз «Метро: Исход» состоится на неделю раньше, чем мы ожидали.','Третье DLC для Marvel’s Spider-Man выйдет через неделю':'До конца года Insomniac Games выпустит заключительное сюжетное DLC для Marvel’s Spider-Man, названное Silver Lining. Сегодня авторы поделились подробностями о добавке в блоге PlayStation.','Империум Человечества':'Империум Человечества - галактическая империя, объединившая подавляющее большинство людей в галактике. Его основатель и правитель - богоподобный Император Человечества, самый могущественный псайкер, известный человечеству. Он основал Империум более двенадцати тысяч лет назад и продолжает, пусть и номинально, возглавлять его. Официальным гербом государства является Аквила. ','Адептус Астартес':'Адептус Астартес (больше известные как космические десантники или Ангелы Смерти) - одни из самых элитных и устрашающих вооружённых сил Империума. Основная организационная единица Астартес - Орден, самостоятельная армия. Существует более тысячи Орденов, но все равно этого слишком мало для того, чтобы считать космических десантников основной военной силой Империума. Вместо этого они выступают в роли высокомобильных ударных сил. Им поручают выполнение самых опасных заданий, таких как молниеносные рейды в тылу противника, операции по проникновению и битвы в замкнутых пространствах. Космодесантники проходят жесточайший отбор, тренировки, духовную и психическую подготовку и в десятки раз превосходят других воинов Империума. ','Лорд-Командующий Солар Махарий':'«Что есть сильнейшее оружие Человечества? Божественные машины Адептус Механикус? Нет! Легионы Астартес? Нет! Танк? Лазган? Кулак? Нет, нет и нет! Мужество, и только мужество стоит превыше их всех!»','Происхождение Имперской Гвардии ':'Имперская Гвардия, как регулярные вооружённые силы Империума, появилась во времена Великого крестового похода десять тысяч лет назад. В те времена она называлась Имперской Армией. После событий Ереси Хоруса Имперская Армия была разделена на две организации: Имперскую Гвардию и Имперский Флот. Это было сделано для того, чтобы предотвратить повторение таких масштабных восстаний, разделив космический флот и наземную армию. ','Инквизиция':'Святые Ордена Императорской Инквизиции, чаще называемые просто Инквизицией - могущественная секретная полиция Империума, призванная защищать души людей. Предназначение Инквизиции - выявлять и уничтожать мириады потенциальных угроз Империуму и всему человечеству. Члены этой организации известны как инквизиторы. ','Высший лорд-инквизитор Карамазов ':'В моём суде нет такой вещи, как прошение о невиновности. Просящий о невиновности виновен в отнятии у меня ценного времени. Виновен. ','Фабий Байл при Осквернении Канзуза 9':'Если человек тратит свою жизнь на благие дела и заботу о ближнем, он умирает без благодарностей и воспоминаний. Если его гений принес горе и смерть миллиардам, его имя будут вспоминать спустя тысячелетия и сотни поколений. Ужасная репутация всегда предпочтительнее безвестности. ','Капитан Рок, III Катачанский полк «Зелёные Дьяволы», о планете Варестус Прайм':'«…Мы нарвались на скорпионов, каждый размером с боевой танк, три человека умерли от глазной гнили на прошлой неделе. Я потею так, что можно наполнить озеро, мои ботинки засосала трясина, а деревья тут такие толстые местами, что между ними не пролезть. Император, помоги мне — я люблю это место! Здесь совсем как дома!» ','Эпиграф к книгам про Грегора Эйзенхорна':'«Размышления порождают ересь. Ересь порождает возмездие.» ','Комиссар Яррик':'Имя нам Легион. Крови нашей — Океан. Мы не боги и не титаны. Мы солдаты. Мы не умираем. Мы отправляемся в ад на перегруппировку.','Девизы Империума Людей':'Будь смел в своих невежествах.В труде ты обретёшь Спасение.В чистом разуме нет места сомнениям.Великодушие — признак слабости.Вера должна быть подкреплена делами.Верный раб любит свою плеть.Вопросы задают дураки; повторяют их дважды — идиоты.Воспитай человека без веры и получишь разумного еретика.Все души жаждут спасения.Выкорчёвывай корни ереси, а не рви её ветки.Будь сильным в своём незнании.Милосердие — признак слабости.Раскайся! Ведь завтра ты умрёшь.','WAAAAAGH!!!':'Не используйте силовые мечи для резки хлеба, парни!Не наклеивайте надпись «Погуди, если думаешь, что мы ***» на транспорты Сестер Битвы.Мы орки - парни весёлые, хотите мы вам бошки разобьём - смеяться будем!Надо что-то сжечь, а то получается не убил никого и не покалечил за день.И какой я орк?!Коли голова болит, давай я тебе дырочку в шлеме сделаю - полегчает.Научитесь не только жрать в свою башку, но и думать!!!','Фиолетовые орки':'Фиолетовый - орки верят, что этот цвет повышает незаметность. Нет, невидимость он им не дает, орк окрашенный в фиолетовый не может, спокойно пройти сквозь строй космодесанта, зайти в каюту капеллана и выпить весь кагор. Не получится это. Но! Но!! Если орк будет верить, что он крадется, "и вааще крута маскируется" и при этом он одет или покрашен в фиолетовый, то капеллан даже в самой защищенной крепости своего кагора не досчитается. И да, никакие системы слежения и наблюдения не помогут, если орк верит, что он "крутай разветчик"!','Синие орки':'Орки верят, что синий цвет повышает удачу. И это реально работает! Правда у орков и только у них. Увидите синего орка в казино, гоните его в шею, обнесет всё и все джекпоты выиграет!',}

def randstr():
    n = int(random.uniform(10, 50))
    a = string.ascii_letters + string.digits
    return(str(''.join([random.choice(a) for i in range(n)])))

def make_md5(s, encoding='utf-8'):
    return md5(s.encode(encoding)).hexdigest()

def string2numeric_hash(text, encoding='utf-8'):
    return int(md5(text.encode(encoding)).hexdigest()[:8], 16)

def check(hostname):
    try:
        r = requests.get('http://%s:%s' % (hostname, PORT), headers={'User-Agent': ua.random},timeout=5)

        if (r.status_code != 200):
            return(DOWN)

        return(SUCCESS)
    except requests.exceptions.ConnectionError:
        return(DOWN)
    except requests.exceptions.ReadTimeout:
        return(MUMBLE)
    except:
        print('unknown err', exc_info())
        return(ERROR)

def put(hostname, uid, flag):
    try:
        HEADER = {'User-Agent': ua.random}
        url = 'http://%s:%s' % (hostname, PORT)
        put = False
        with requests.Session() as s:
            regData = {
                'username': make_md5(uid+'pCTF18log'),
                'password':   string2numeric_hash(uid+'pCTF18pass'),
                'password_repeat': string2numeric_hash(uid+'pCTF18pass'),
            }
            r = s.post(url + '/register/',data=regData, headers=HEADER, timeout=15)

            if (r.status_code != 200):

                return(MUMBLE)

            logData = {
                'username'    : make_md5(uid+'pCTF18log'),
                'password' : string2numeric_hash(uid+'pCTF18pass'),
                #'do_login' : ''
            }
            l = s.post(url + '/login/',data=logData, headers=HEADER, timeout=15)
#            print(l.status_code)
            if (l.status_code != 200):
                print(l.status_code)
                return(MUMBLE)
            wer=random.choice(list(textmassiv.items()))
            #print (wer[0])
            #print (textmassiv['Знакомство с OpenGL'])
            postingData = {
                'title':  wer[0],
                'text':  wer[1] ,
                'flag': flag
            }

            p = s.post(url + '/post/new/',data=postingData, headers=HEADER, timeout=15)

            if (p.status_code != 200):

                return(MUMBLE)
            else:
                put = True

        if put:
            return(SUCCESS)

        return(MUMBLE)
    except requests.exceptions.ConnectionError:
        return(DOWN)
    except requests.exceptions.ReadTimeout:
        return(MUMBLE)
    except:
        print('unknown err', exc_info())
        return(ERROR)

def get(hostname, uid, flag):
    try:
        HEADER = {'User-Agent': ua.random}
        url = 'http://%s:%s' % (hostname, PORT)
        get = False
        with requests.Session() as s:
            logData = {
                'username'    : make_md5(uid+'pCTF18log'),
                'password' : string2numeric_hash(uid+'pCTF18pass'),
                #'do_login' : ''
            }
            l = s.post(url + '/login/',data=logData, headers=HEADER, timeout=5)
#            print('OK')
            if (l.status_code != 200):
                return(MUMBLE)

            g = s.get(url + '/post/last/', headers=HEADER, timeout=5)
 #           print(g)
            if (g.status_code != 200):
                return(MUMBLE)
 #           print('OK')
            oru = s.get(url +'/search/', headers=HEADER, timeout=5)
            
            if (oru.status_code != 200):
                return(CORRUPT)
  #          print('OK')
            if re.search(flag, str(g.text)):

                get = True
 #               print ('OK')
            else:
  #              print ('NOT OK')
                return(CORRUPT)

        if get:
            return(SUCCESS)
    except requests.exceptions.ConnectionError:
        return(DOWN)
    except requests.exceptions.ReadTimeout:
        return(MUMBLE)
    except:
        print('unknown err', exc_info())
        return(ERROR)

if __name__ == '__main__':
    res = False
    if len(argv) > 1:
        if argv[1] == "check":
            if len(argv) > 2:
                res = check(argv[2])
        elif argv[1] == "put":
            if len(argv) > 4:
                res = put(argv[2], argv[3], argv[4])

        elif argv[1] == "get":
            if len(argv) > 4:
                res = get(argv[2], argv[3], argv[4])
        if res:
            if DEBUG:
                print(res)
            exit(res)
    exit(ERROR)
